// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from smacc2_msgs:msg/SmaccTransition.idl
// generated code does not contain a copyright notice
#include "smacc2_msgs/msg/detail/smacc_transition__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `transition_name`
// Member `transition_type`
// Member `destiny_state_name`
// Member `source_state_name`
#include "rosidl_runtime_c/string_functions.h"
// Member `event`
#include "smacc2_msgs/msg/detail/smacc_event__functions.h"

bool
smacc2_msgs__msg__SmaccTransition__init(smacc2_msgs__msg__SmaccTransition * msg)
{
  if (!msg) {
    return false;
  }
  // index
  // transition_name
  if (!rosidl_runtime_c__String__init(&msg->transition_name)) {
    smacc2_msgs__msg__SmaccTransition__fini(msg);
    return false;
  }
  // transition_type
  if (!rosidl_runtime_c__String__init(&msg->transition_type)) {
    smacc2_msgs__msg__SmaccTransition__fini(msg);
    return false;
  }
  // destiny_state_name
  if (!rosidl_runtime_c__String__init(&msg->destiny_state_name)) {
    smacc2_msgs__msg__SmaccTransition__fini(msg);
    return false;
  }
  // source_state_name
  if (!rosidl_runtime_c__String__init(&msg->source_state_name)) {
    smacc2_msgs__msg__SmaccTransition__fini(msg);
    return false;
  }
  // history_node
  // event
  if (!smacc2_msgs__msg__SmaccEvent__init(&msg->event)) {
    smacc2_msgs__msg__SmaccTransition__fini(msg);
    return false;
  }
  return true;
}

void
smacc2_msgs__msg__SmaccTransition__fini(smacc2_msgs__msg__SmaccTransition * msg)
{
  if (!msg) {
    return;
  }
  // index
  // transition_name
  rosidl_runtime_c__String__fini(&msg->transition_name);
  // transition_type
  rosidl_runtime_c__String__fini(&msg->transition_type);
  // destiny_state_name
  rosidl_runtime_c__String__fini(&msg->destiny_state_name);
  // source_state_name
  rosidl_runtime_c__String__fini(&msg->source_state_name);
  // history_node
  // event
  smacc2_msgs__msg__SmaccEvent__fini(&msg->event);
}

smacc2_msgs__msg__SmaccTransition *
smacc2_msgs__msg__SmaccTransition__create()
{
  smacc2_msgs__msg__SmaccTransition * msg = (smacc2_msgs__msg__SmaccTransition *)malloc(sizeof(smacc2_msgs__msg__SmaccTransition));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(smacc2_msgs__msg__SmaccTransition));
  bool success = smacc2_msgs__msg__SmaccTransition__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
smacc2_msgs__msg__SmaccTransition__destroy(smacc2_msgs__msg__SmaccTransition * msg)
{
  if (msg) {
    smacc2_msgs__msg__SmaccTransition__fini(msg);
  }
  free(msg);
}


bool
smacc2_msgs__msg__SmaccTransition__Sequence__init(smacc2_msgs__msg__SmaccTransition__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  smacc2_msgs__msg__SmaccTransition * data = NULL;
  if (size) {
    data = (smacc2_msgs__msg__SmaccTransition *)calloc(size, sizeof(smacc2_msgs__msg__SmaccTransition));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = smacc2_msgs__msg__SmaccTransition__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        smacc2_msgs__msg__SmaccTransition__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
smacc2_msgs__msg__SmaccTransition__Sequence__fini(smacc2_msgs__msg__SmaccTransition__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      smacc2_msgs__msg__SmaccTransition__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

smacc2_msgs__msg__SmaccTransition__Sequence *
smacc2_msgs__msg__SmaccTransition__Sequence__create(size_t size)
{
  smacc2_msgs__msg__SmaccTransition__Sequence * array = (smacc2_msgs__msg__SmaccTransition__Sequence *)malloc(sizeof(smacc2_msgs__msg__SmaccTransition__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = smacc2_msgs__msg__SmaccTransition__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
smacc2_msgs__msg__SmaccTransition__Sequence__destroy(smacc2_msgs__msg__SmaccTransition__Sequence * array)
{
  if (array) {
    smacc2_msgs__msg__SmaccTransition__Sequence__fini(array);
  }
  free(array);
}
